/**
* @module vue-mdc-adaptercard 0.7.2
* @exports VueMDCCard
* @copyright (c) 2017-present, Sebastien Tasson
* @license https://opensource.org/licenses/MIT
* @implements {"material-components-web":"^0.27.0"}
* @requires {"vue":"^2.5.6"}
* @see https://github.com/stasson/vue-mdc-adapter
*/
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):t.VueMDCCard=e()}(this,function(){"use strict";var t={components:{CustomElement:{functional:!0,render:function(t,e){return t(e.props.is||e.props.tag||"div",e.data,e.children)}}}},e=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")},a=function(){function t(t,e){for(var a=0;a<e.length;a++){var i=e[a];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(t,i.key,i)}}return function(e,a,i){return a&&t(e.prototype,a),i&&t(e,i),e}}(),i=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var a=arguments[e];for(var i in a)Object.prototype.hasOwnProperty.call(a,i)&&(t[i]=a[i])}return t},n=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function, not "+typeof e);t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}}),e&&(Object.setPrototypeOf?Object.setPrototypeOf(t,e):t.__proto__=e)},r=function(t,e){if(!t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!e||"object"!=typeof e&&"function"!=typeof e?t:e},s={props:{event:String,"event-target":Object,"event-args":Array},methods:{dispatchEvent:function(t){if(this.$emit(t.type),this.event){var e=this.eventTarget||this.$root,a=this.eventArgs||[];e.$emit.apply(e,[this.event].concat(function(t){if(Array.isArray(t)){for(var e=0,a=Array(t.length);e<t.length;e++)a[e]=t[e];return a}return Array.from(t)}(a)))}}}},o={render:function(){var t=this.$createElement;return(this._self._c||t)("div",{staticClass:"mdc-card",class:this.classes},[this._t("default")],2)},staticRenderFns:[],name:"mdc-card",props:{dark:Boolean},data:function(){return{classes:{"mdc-card--theme-dark":this.dark}}}},c={render:function(){var t=this.$createElement;return(this._self._c||t)("section",{staticClass:"mdc-card-media mdc-card__media",style:this.styles,attrs:{classes:{"mdc-theme--dark":this.dark}}},[this._t("default")],2)},staticRenderFns:[],name:"mdc-card-media",props:{src:String,size:String,position:String,height:[String,Number],dark:Boolean},computed:{styles:function(){var t={backgroundImage:"url("+this.src+")",backgroundSize:this.size,backgroundPosition:this.position};return this.height&&(t.height=this.height+"px"),t}}},d={render:function(){var t=this,e=t.$createElement,a=t._self._c||e;return a("section",{staticClass:"mdc-card-header mdc-card__primary"},[t._t("default",[t.title?a("h1",{staticClass:"mdc-card__title",class:{"mdc-card__title--large":t.largeTitle}},[t._v(" "+t._s(t.title)+" ")]):t._e(),t._v(" "),t.subtitle?a("h2",{staticClass:"mdc-card__subtitle"},[t._v(" "+t._s(t.subtitle)+" ")]):t._e()])],2)},staticRenderFns:[],name:"mdc-card-header",props:{title:String,subtitle:String,"large-title":{type:Boolean,default:!0}}},u={render:function(){var t=this.$createElement;return(this._self._c||t)("h1",{staticClass:"mdc-card-title mdc-card__title",class:{"mdc-card__title--large":this.large}},[this._t("default")],2)},staticRenderFns:[],name:"mdc-card-title",props:{large:Boolean}},l={render:function(){var t=this.$createElement;return(this._self._c||t)("img",{staticClass:"mdc-card-img mdc-card__media-item",class:this.classes,attrs:{src:this.src}})},staticRenderFns:[],name:"mdc-card-img",props:{src:{type:String,required:!0},mult:{type:[Number,String],validator:function(t){return-1!==[1,1.5,2,3].indexOf(Number(t))}}},computed:{classes:function(){var t=Number(this.mult);return{"mdc-card__media-item--1dot5x":1.5===t,"mdc-card__media-item--2x":2===t,"mdc-card__media-item--3x":3===t}}}},f=function(){function t(){var a=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};e(this,t),this.adapter_=a}return a(t,null,[{key:"cssClasses",get:function(){return{}}},{key:"strings",get:function(){return{}}},{key:"numbers",get:function(){return{}}},{key:"defaultAdapter",get:function(){return{}}}]),a(t,[{key:"init",value:function(){}},{key:"destroy",value:function(){}}]),t}(),_=(function(){function t(){e(this,t)}a(t,[{key:"browserSupportsCssVars",value:function(){}},{key:"isUnbounded",value:function(){}},{key:"isSurfaceActive",value:function(){}},{key:"isSurfaceDisabled",value:function(){}},{key:"addClass",value:function(t){}},{key:"removeClass",value:function(t){}},{key:"registerInteractionHandler",value:function(t,e){}},{key:"deregisterInteractionHandler",value:function(t,e){}},{key:"registerResizeHandler",value:function(t){}},{key:"deregisterResizeHandler",value:function(t){}},{key:"updateCssVariable",value:function(t,e){}},{key:"computeBoundingRect",value:function(){}},{key:"getWindowPageOffset",value:function(){}}])}(),{ROOT:"mdc-ripple-upgraded",UNBOUNDED:"mdc-ripple-upgraded--unbounded",BG_FOCUSED:"mdc-ripple-upgraded--background-focused",BG_ACTIVE_FILL:"mdc-ripple-upgraded--background-active-fill",FG_ACTIVATION:"mdc-ripple-upgraded--foreground-activation",FG_DEACTIVATION:"mdc-ripple-upgraded--foreground-deactivation"}),m={VAR_FG_SIZE:"--mdc-ripple-fg-size",VAR_LEFT:"--mdc-ripple-left",VAR_TOP:"--mdc-ripple-top",VAR_FG_SCALE:"--mdc-ripple-fg-scale",VAR_FG_TRANSLATE_START:"--mdc-ripple-fg-translate-start",VAR_FG_TRANSLATE_END:"--mdc-ripple-fg-translate-end"},h={PADDING:10,INITIAL_ORIGIN_SCALE:.6,DEACTIVATION_TIMEOUT_MS:225,FG_DEACTIVATION_MS:150},v=void 0,p={mouseup:"mousedown",pointerup:"pointerdown",touchend:"touchstart",keyup:"keydown",blur:"focus"},g=function(t){function s(t){e(this,s);var a=r(this,(s.__proto__||Object.getPrototypeOf(s)).call(this,i(s.defaultAdapter,t)));return a.layoutFrame_=0,a.frame_={width:0,height:0},a.activationState_=a.defaultActivationState_(),a.xfDuration_=0,a.initialSize_=0,a.maxRadius_=0,a.listenerInfos_=[{activate:"touchstart",deactivate:"touchend"},{activate:"pointerdown",deactivate:"pointerup"},{activate:"mousedown",deactivate:"mouseup"},{activate:"keydown",deactivate:"keyup"},{focus:"focus",blur:"blur"}],a.listeners_={activate:function(t){return a.activate_(t)},deactivate:function(t){return a.deactivate_(t)},focus:function(){return requestAnimationFrame(function(){return a.adapter_.addClass(s.cssClasses.BG_FOCUSED)})},blur:function(){return requestAnimationFrame(function(){return a.adapter_.removeClass(s.cssClasses.BG_FOCUSED)})}},a.resizeHandler_=function(){return a.layout()},a.unboundedCoords_={left:0,top:0},a.fgScale_=0,a.activationTimer_=0,a.fgDeactivationRemovalTimer_=0,a.activationAnimationHasEnded_=!1,a.activationTimerCallback_=function(){a.activationAnimationHasEnded_=!0,a.runDeactivationUXLogicIfReady_()},a}return n(s,f),a(s,null,[{key:"cssClasses",get:function(){return _}},{key:"strings",get:function(){return m}},{key:"numbers",get:function(){return h}},{key:"defaultAdapter",get:function(){return{browserSupportsCssVars:function(){},isUnbounded:function(){},isSurfaceActive:function(){},isSurfaceDisabled:function(){},addClass:function(){},removeClass:function(){},registerInteractionHandler:function(){},deregisterInteractionHandler:function(){},registerResizeHandler:function(){},deregisterResizeHandler:function(){},updateCssVariable:function(){},computeBoundingRect:function(){},getWindowPageOffset:function(){}}}}]),a(s,[{key:"isSupported_",value:function(){return this.adapter_.browserSupportsCssVars()}},{key:"defaultActivationState_",value:function(){return{isActivated:!1,hasDeactivationUXRun:!1,wasActivatedByPointer:!1,wasElementMadeActive:!1,activationStartTime:0,activationEvent:null,isProgrammatic:!1}}},{key:"init",value:function(){var t=this;if(this.isSupported_()){this.addEventListeners_();var e=s.cssClasses,a=e.ROOT,i=e.UNBOUNDED;requestAnimationFrame(function(){t.adapter_.addClass(a),t.adapter_.isUnbounded()&&t.adapter_.addClass(i),t.layoutInternal_()})}}},{key:"addEventListeners_",value:function(){var t=this;this.listenerInfos_.forEach(function(e){Object.keys(e).forEach(function(a){t.adapter_.registerInteractionHandler(e[a],t.listeners_[a])})}),this.adapter_.registerResizeHandler(this.resizeHandler_)}},{key:"activate_",value:function(t){var e=this;if(!this.adapter_.isSurfaceDisabled()){var a=this.activationState_;a.isActivated||(a.isActivated=!0,a.isProgrammatic=null===t,a.activationEvent=t,a.wasActivatedByPointer=!a.isProgrammatic&&("mousedown"===t.type||"touchstart"===t.type||"pointerdown"===t.type),a.activationStartTime=Date.now(),requestAnimationFrame(function(){a.wasElementMadeActive=!t||"keydown"!==t.type||e.adapter_.isSurfaceActive(),a.wasElementMadeActive?e.animateActivation_():e.activationState_=e.defaultActivationState_()}))}}},{key:"activate",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this.activate_(t)}},{key:"animateActivation_",value:function(){var t=this,e=s.strings,a=e.VAR_FG_TRANSLATE_START,i=e.VAR_FG_TRANSLATE_END,n=s.cssClasses,r=n.BG_ACTIVE_FILL,o=n.FG_DEACTIVATION,c=n.FG_ACTIVATION,d=s.numbers.DEACTIVATION_TIMEOUT_MS,u="",l="";if(!this.adapter_.isUnbounded()){var f=this.getFgTranslationCoordinates_(),_=f.startPoint,m=f.endPoint;u=_.x+"px, "+_.y+"px",l=m.x+"px, "+m.y+"px"}this.adapter_.updateCssVariable(a,u),this.adapter_.updateCssVariable(i,l),clearTimeout(this.activationTimer_),clearTimeout(this.fgDeactivationRemovalTimer_),this.rmBoundedActivationClasses_(),this.adapter_.removeClass(o),this.adapter_.computeBoundingRect(),this.adapter_.addClass(r),this.adapter_.addClass(c),this.activationTimer_=setTimeout(function(){return t.activationTimerCallback_()},d)}},{key:"getFgTranslationCoordinates_",value:function(){var t=this.activationState_,e=t.activationEvent,a=void 0;return{startPoint:a={x:(a=t.wasActivatedByPointer?function(t,e,a){var i=e.x,n=e.y,r=i+a.left,s=n+a.top,o=void 0,c=void 0;return"touchstart"===t.type?(o=t.changedTouches[0].pageX-r,c=t.changedTouches[0].pageY-s):(o=t.pageX-r,c=t.pageY-s),{x:o,y:c}}(e,this.adapter_.getWindowPageOffset(),this.adapter_.computeBoundingRect()):{x:this.frame_.width/2,y:this.frame_.height/2}).x-this.initialSize_/2,y:a.y-this.initialSize_/2},endPoint:{x:this.frame_.width/2-this.initialSize_/2,y:this.frame_.height/2-this.initialSize_/2}}}},{key:"runDeactivationUXLogicIfReady_",value:function(){var t=this,e=s.cssClasses.FG_DEACTIVATION,a=this.activationState_,i=a.hasDeactivationUXRun,n=a.isActivated;(i||!n)&&this.activationAnimationHasEnded_&&(this.rmBoundedActivationClasses_(),this.adapter_.addClass(e),this.fgDeactivationRemovalTimer_=setTimeout(function(){t.adapter_.removeClass(e)},h.FG_DEACTIVATION_MS))}},{key:"rmBoundedActivationClasses_",value:function(){var t=s.cssClasses,e=t.BG_ACTIVE_FILL,a=t.FG_ACTIVATION;this.adapter_.removeClass(e),this.adapter_.removeClass(a),this.activationAnimationHasEnded_=!1,this.adapter_.computeBoundingRect()}},{key:"deactivate_",value:function(t){var e=this,a=this.activationState_;if(a.isActivated){if(a.isProgrammatic){var n=i({},a);return requestAnimationFrame(function(){return e.animateDeactivation_(null,n)}),void(this.activationState_=this.defaultActivationState_())}var r=p[t.type]===a.activationEvent.type,s=r;a.wasActivatedByPointer&&(s="mouseup"===t.type);var o=i({},a);requestAnimationFrame(function(){r&&(e.activationState_.hasDeactivationUXRun=!0,e.animateDeactivation_(t,o)),s&&(e.activationState_=e.defaultActivationState_())})}}},{key:"deactivate",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this.deactivate_(t)}},{key:"animateDeactivation_",value:function(t,e){var a=e.wasActivatedByPointer,i=e.wasElementMadeActive,n=s.cssClasses.BG_FOCUSED;(a||i)&&(this.adapter_.removeClass(n),this.runDeactivationUXLogicIfReady_())}},{key:"destroy",value:function(){var t=this;if(this.isSupported_()){this.removeEventListeners_();var e=s.cssClasses,a=e.ROOT,i=e.UNBOUNDED;requestAnimationFrame(function(){t.adapter_.removeClass(a),t.adapter_.removeClass(i),t.removeCssVars_()})}}},{key:"removeEventListeners_",value:function(){var t=this;this.listenerInfos_.forEach(function(e){Object.keys(e).forEach(function(a){t.adapter_.deregisterInteractionHandler(e[a],t.listeners_[a])})}),this.adapter_.deregisterResizeHandler(this.resizeHandler_)}},{key:"removeCssVars_",value:function(){var t=this,e=s.strings;Object.keys(e).forEach(function(a){0===a.indexOf("VAR_")&&t.adapter_.updateCssVariable(e[a],null)})}},{key:"layout",value:function(){var t=this;this.layoutFrame_&&cancelAnimationFrame(this.layoutFrame_),this.layoutFrame_=requestAnimationFrame(function(){t.layoutInternal_(),t.layoutFrame_=0})}},{key:"layoutInternal_",value:function(){this.frame_=this.adapter_.computeBoundingRect();var t=Math.max(this.frame_.height,this.frame_.width),e=Math.sqrt(Math.pow(this.frame_.width,2)+Math.pow(this.frame_.height,2));this.initialSize_=t*s.numbers.INITIAL_ORIGIN_SCALE,this.maxRadius_=e+s.numbers.PADDING,this.fgScale_=this.maxRadius_/this.initialSize_,this.xfDuration_=1e3*Math.sqrt(this.maxRadius_/1024),this.updateLayoutCssVars_()}},{key:"updateLayoutCssVars_",value:function(){var t=s.strings,e=t.VAR_FG_SIZE,a=t.VAR_LEFT,i=t.VAR_TOP,n=t.VAR_FG_SCALE;this.adapter_.updateCssVariable(e,this.initialSize_+"px"),this.adapter_.updateCssVariable(n,this.fgScale_),this.adapter_.isUnbounded()&&(this.unboundedCoords_={left:Math.round(this.frame_.width/2-this.initialSize_/2),top:Math.round(this.frame_.height/2-this.initialSize_/2)},this.adapter_.updateCssVariable(a,this.unboundedCoords_.left+"px"),this.adapter_.updateCssVariable(i,this.unboundedCoords_.top+"px"))}}]),s}(),y=function(t){function s(t,a){return e(this,s),r(this,(s.__proto__||Object.getPrototypeOf(s)).call(this,i({browserSupportsCssVars:function(){return function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if("boolean"==typeof v&&!e)return v;if(t.CSS&&"function"==typeof t.CSS.supports){var a=t.CSS.supports("--css-vars","yes"),i=t.CSS.supports("(--css-vars: yes)")&&t.CSS.supports("color","#00000000");return v=!(!a&&!i||function(t){var e=t.document,a=e.createElement("div");a.className="mdc-ripple-surface--test-edge-var-bug",e.body.appendChild(a);var i=t.getComputedStyle(a),n=null!==i&&"solid"===i.borderTopStyle;return a.remove(),n}(t))}}(window)},registerResizeHandler:function(t){return window.addEventListener("resize",t)},deregisterResizeHandler:function(t){return window.removeEventListener("resize",t)},getWindowPageOffset:function(){return{x:window.pageXOffset,y:window.pageYOffset}},isUnbounded:function(){return!1},computeBoundingRect:function(){return t.$el.getBoundingClientRect()},isSurfaceActive:function(){return t.$el[s.MATCHES](":active")},isSurfaceDisabled:function(){return t.disabled},addClass:function(e){t.$set(t.classes,e,!0)},removeClass:function(e){t.$delete(t.classes,e)},registerInteractionHandler:function(e,a){t.$el.addEventListener(e,a)},deregisterInteractionHandler:function(e,a){t.$el.removeEventListener(e,a)},updateCssVariable:function(e,a){t.$set(t.styles,e,a)}},a)))}return n(s,g),a(s,null,[{key:"isSurfaceActive",value:function(t){return t[s.MATCHES](":active")}},{key:"MATCHES",get:function(){return s._matches||(s._matches=function(t){return["webkitMatchesSelector","msMatchesSelector","matches"].filter(function(e){return e in t}).pop()}(HTMLElement.prototype))}}]),s}(),C={render:function(){var t=this,e=t.$createElement;return(t._self._c||e)("custom-element",{ref:"root",staticClass:"mdc-card-action-button",class:t.classes,style:t.styles,attrs:{tag:t.isLink?"a":"button",href:t.isLink&&t.href,role:t.isLink?"button":void 0,disabled:t.disabled},on:{click:t.dispatchEvent}},[t._t("default")],2)},staticRenderFns:[],name:"mdc-card-action-button",mixins:[s,t],props:{href:String,disabled:Boolean},data:function(){return{classes:{"mdc-button":!0,"mdc-button--compact":!0,"mdc-card__action":!0},styles:{}}},computed:{isLink:function(){return this.href&&!this.disabled}},mounted:function(){this.ripple=new y(this),this.ripple.init()},beforeDestroy:function(){this.ripple.destroy()}},A=function(t){return{install:function(e){for(var a in t){var i=t[a];e.component(i.name,i)}},components:t}}({mdcCard:o,mdcCardMedia:c,mdcCardHeader:d,mdcCardTitle:u,mdcCardSubtitle:{render:function(){var t=this.$createElement;return(this._self._c||t)("h2",{staticClass:"mdc-card-subtitle mdc-card__subtitle"},[this._t("default")],2)},staticRenderFns:[],name:"mdc-card-subtitle"},mdcCardText:{render:function(){var t=this.$createElement;return(this._self._c||t)("section",{staticClass:"mdc-card-text mdc-card__supporting-text"},[this._t("default")],2)},staticRenderFns:[],name:"mdc-card-text"},mdcCardHorizontal:{render:function(){var t=this.$createElement;return(this._self._c||t)("div",{staticClass:"mdc-card-horizontal mdc-card__horizontal-block"},[this._t("default")],2)},staticRenderFns:[],name:"mdc-card-horizontal"},mdcCardImg:l,mdcCardActions:{render:function(){var t=this.$createElement;return(this._self._c||t)("section",{staticClass:"mdc-card-actions",class:this.classes},[this._t("default")],2)},staticRenderFns:[],name:"mdc-card-actions",props:{vertical:Boolean},components:{"mdc-card-action-button":C},data:function(){return{classes:{"mdc-card__actions":!0,"mdc-card__actions--vertical":this.vertical}}}},mdcCardActionButton:C});return function(t){var e=null;"undefined"!=typeof window?e=window.Vue:"undefined"!=typeof global&&(e=global.Vue),e&&e.use(t)}(A),A});
//# sourceMappingURL=card.min.js.map
